-- do not edit; automatically generated by UU_AG
module PrettyPrinting where

import UHA_Syntax
import Utils (internalError)

import PPrint
import Char
import List (intersperse)
import Types (isTupleConstructor)

intErr = internalError "UHA_Pretty"

opt = maybe empty id

parensIf     p  n  = if p then parens n else n
parensIfList ps ns = map (uncurry parensIf) (zip ps ns)

tupled1 []  = empty
tupled1 xs  = tupled xs

tupled2 []  = empty
tupled2 xs  = tupledUnit xs

tupledUnit [x] = x
tupledUnit xs  = tupled xs

commas :: [Doc] -> Doc
commas docs =
    hcat (punctuate (comma <+> empty) docs)

utrechtList :: Doc -> Doc -> [Doc] -> Doc
utrechtList start end []     = empty
utrechtList start end (d:ds) =
    let utrechtList' []     = end
        utrechtList' (d:ds) = comma <+> d <$> utrechtList' ds
    in
        start <+> d <$> utrechtList' ds
        
-- Alternative -------------------------------------------------
-- semantic domain
type T_Alternative = ((Doc))
-- cata
sem_Alternative :: (Alternative) ->
                   (T_Alternative)
sem_Alternative ((Alternative_Alternative (_range) (_pattern) (_righthandside))) =
    (sem_Alternative_Alternative ((sem_Range (_range))) ((sem_Pattern (_pattern))) ((sem_RightHandSide (_righthandside))))
sem_Alternative ((Alternative_Empty (_range))) =
    (sem_Alternative_Empty ((sem_Range (_range))))
sem_Alternative_Alternative :: (T_Range) ->
                               (T_Pattern) ->
                               (T_RightHandSide) ->
                               (T_Alternative)
sem_Alternative_Alternative (_range) (_pattern) (_righthandside) =
    let (_text) =
            _pattern_text <$> indent 2 (_righthandside_text (text "->"))
        ( _range_text) =
            (_range )
        ( _pattern_text) =
            (_pattern )
        ( _righthandside_text) =
            (_righthandside )
    in  (_text)
sem_Alternative_Empty :: (T_Range) ->
                         (T_Alternative)
sem_Alternative_Empty (_range) =
    let (_text) =
            empty
        ( _range_text) =
            (_range )
    in  (_text)
-- Alternatives ------------------------------------------------
-- semantic domain
type T_Alternatives = (( [       Doc ] ))
-- cata
sem_Alternatives :: (Alternatives) ->
                    (T_Alternatives)
sem_Alternatives (list) =
    (foldr (sem_Alternatives_Cons) (sem_Alternatives_Nil) ((map sem_Alternative list)))
sem_Alternatives_Cons :: (T_Alternative) ->
                         (T_Alternatives) ->
                         (T_Alternatives)
sem_Alternatives_Cons (_hd) (_tl) =
    let ( _hd_text) =
            (_hd )
        ( _tl_text) =
            (_tl )
    in  (_hd_text  :  _tl_text)
sem_Alternatives_Nil :: (T_Alternatives)
sem_Alternatives_Nil  =
    let 
    in  ([])
-- AnnotatedType -----------------------------------------------
-- semantic domain
type T_AnnotatedType = ((Doc))
-- cata
sem_AnnotatedType :: (AnnotatedType) ->
                     (T_AnnotatedType)
sem_AnnotatedType ((AnnotatedType_AnnotatedType (_range) (_strict) (_type))) =
    (sem_AnnotatedType_AnnotatedType ((sem_Range (_range))) (_strict) ((sem_Type (_type))))
sem_AnnotatedType_AnnotatedType :: (T_Range) ->
                                   (Bool) ->
                                   (T_Type) ->
                                   (T_AnnotatedType)
sem_AnnotatedType_AnnotatedType (_range) (_strict) (_type) =
    let (_text) =
            (if _strict then (text "!" <+>) else id) _type_text
        ( _range_text) =
            (_range )
        ( _type_text) =
            (_type )
    in  (_text)
-- AnnotatedTypes ----------------------------------------------
-- semantic domain
type T_AnnotatedTypes = (( [       Doc ] ))
-- cata
sem_AnnotatedTypes :: (AnnotatedTypes) ->
                      (T_AnnotatedTypes)
sem_AnnotatedTypes (list) =
    (foldr (sem_AnnotatedTypes_Cons) (sem_AnnotatedTypes_Nil) ((map sem_AnnotatedType list)))
sem_AnnotatedTypes_Cons :: (T_AnnotatedType) ->
                           (T_AnnotatedTypes) ->
                           (T_AnnotatedTypes)
sem_AnnotatedTypes_Cons (_hd) (_tl) =
    let ( _hd_text) =
            (_hd )
        ( _tl_text) =
            (_tl )
    in  (_hd_text  :  _tl_text)
sem_AnnotatedTypes_Nil :: (T_AnnotatedTypes)
sem_AnnotatedTypes_Nil  =
    let 
    in  ([])
-- Body --------------------------------------------------------
-- semantic domain
type T_Body = ((Doc))
-- cata
sem_Body :: (Body) ->
            (T_Body)
sem_Body ((Body_Body (_range) (_importdeclarations) (_declarations))) =
    (sem_Body_Body ((sem_Range (_range))) ((sem_ImportDeclarations (_importdeclarations))) ((sem_Declarations (_declarations))))
sem_Body_Body :: (T_Range) ->
                 (T_ImportDeclarations) ->
                 (T_Declarations) ->
                 (T_Body)
sem_Body_Body (_range) (_importdeclarations) (_declarations) =
    let (_text) =
            vcat
                     (   _importdeclarations_text
                     ++                        _declarations_text
                     )
        ( _range_text) =
            (_range )
        ( _importdeclarations_text) =
            (_importdeclarations )
        ( _declarations_text) =
            (_declarations )
    in  (_text)
-- Constructor -------------------------------------------------
-- semantic domain
type T_Constructor = ((Doc))
-- cata
sem_Constructor :: (Constructor) ->
                   (T_Constructor)
sem_Constructor ((Constructor_Constructor (_range) (_constructor) (_types))) =
    (sem_Constructor_Constructor ((sem_Range (_range))) ((sem_Name (_constructor))) ((sem_AnnotatedTypes (_types))))
sem_Constructor ((Constructor_Infix (_range) (_leftType) (_constructorOperator) (_rightType))) =
    (sem_Constructor_Infix ((sem_Range (_range))) ((sem_AnnotatedType (_leftType))) ((sem_Name (_constructorOperator))) ((sem_AnnotatedType (_rightType))))
sem_Constructor ((Constructor_Record (_range) (_constructor) (_fieldDeclarations))) =
    (sem_Constructor_Record ((sem_Range (_range))) ((sem_Name (_constructor))) ((sem_FieldDeclarations (_fieldDeclarations))))
sem_Constructor_Constructor :: (T_Range) ->
                               (T_Name) ->
                               (T_AnnotatedTypes) ->
                               (T_Constructor)
sem_Constructor_Constructor (_range) (_constructor) (_types) =
    let (_text) =
            foldl (<+>) (parensIf _constructor_isOperator _constructor_text) _types_text
        ( _range_text) =
            (_range )
        ( _constructor_isIdentifier,_constructor_isOperator,_constructor_isSpecial,_constructor_text) =
            (_constructor )
        ( _types_text) =
            (_types )
    in  (_text)
sem_Constructor_Infix :: (T_Range) ->
                         (T_AnnotatedType) ->
                         (T_Name) ->
                         (T_AnnotatedType) ->
                         (T_Constructor)
sem_Constructor_Infix (_range) (_leftType) (_constructorOperator) (_rightType) =
    let (_text) =
            _leftType_text <+> _constructorOperator_text <+> _rightType_text
        ( _range_text) =
            (_range )
        ( _leftType_text) =
            (_leftType )
        ( _constructorOperator_isIdentifier,_constructorOperator_isOperator,_constructorOperator_isSpecial,_constructorOperator_text) =
            (_constructorOperator )
        ( _rightType_text) =
            (_rightType )
    in  (_text)
sem_Constructor_Record :: (T_Range) ->
                          (T_Name) ->
                          (T_FieldDeclarations) ->
                          (T_Constructor)
sem_Constructor_Record (_range) (_constructor) (_fieldDeclarations) =
    let (_text) =
            text "{- !!! record constructor -}"
        ( _range_text) =
            (_range )
        ( _constructor_isIdentifier,_constructor_isOperator,_constructor_isSpecial,_constructor_text) =
            (_constructor )
        ( _fieldDeclarations_text) =
            (_fieldDeclarations )
    in  (_text)
-- Constructors ------------------------------------------------
-- semantic domain
type T_Constructors = (( [       Doc ] ))
-- cata
sem_Constructors :: (Constructors) ->
                    (T_Constructors)
sem_Constructors (list) =
    (foldr (sem_Constructors_Cons) (sem_Constructors_Nil) ((map sem_Constructor list)))
sem_Constructors_Cons :: (T_Constructor) ->
                         (T_Constructors) ->
                         (T_Constructors)
sem_Constructors_Cons (_hd) (_tl) =
    let ( _hd_text) =
            (_hd )
        ( _tl_text) =
            (_tl )
    in  (_hd_text  :  _tl_text)
sem_Constructors_Nil :: (T_Constructors)
sem_Constructors_Nil  =
    let 
    in  ([])
-- ContextItem -------------------------------------------------
-- semantic domain
type T_ContextItem = ((Doc))
-- cata
sem_ContextItem :: (ContextItem) ->
                   (T_ContextItem)
sem_ContextItem ((ContextItem_ContextItem (_range) (_name) (_types))) =
    (sem_ContextItem_ContextItem ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Types (_types))))
sem_ContextItem_ContextItem :: (T_Range) ->
                               (T_Name) ->
                               (T_Types) ->
                               (T_ContextItem)
sem_ContextItem_ContextItem (_range) (_name) (_types) =
    let (_text) =
            foldl (<+>) _name_text _types_text
        ( _range_text) =
            (_range )
        ( _name_isIdentifier,_name_isOperator,_name_isSpecial,_name_text) =
            (_name )
        ( _types_text) =
            (_types )
    in  (_text)
-- ContextItems ------------------------------------------------
-- semantic domain
type T_ContextItems = (( [       Doc ] ))
-- cata
sem_ContextItems :: (ContextItems) ->
                    (T_ContextItems)
sem_ContextItems (list) =
    (foldr (sem_ContextItems_Cons) (sem_ContextItems_Nil) ((map sem_ContextItem list)))
sem_ContextItems_Cons :: (T_ContextItem) ->
                         (T_ContextItems) ->
                         (T_ContextItems)
sem_ContextItems_Cons (_hd) (_tl) =
    let ( _hd_text) =
            (_hd )
        ( _tl_text) =
            (_tl )
    in  (_hd_text  :  _tl_text)
sem_ContextItems_Nil :: (T_ContextItems)
sem_ContextItems_Nil  =
    let 
    in  ([])
-- Declaration -------------------------------------------------
-- semantic domain
type T_Declaration = ((Doc))
-- cata
sem_Declaration :: (Declaration) ->
                   (T_Declaration)
sem_Declaration ((Declaration_Class (_range) (_context) (_simpletype) (_where))) =
    (sem_Declaration_Class ((sem_Range (_range))) ((sem_ContextItems (_context))) ((sem_SimpleType (_simpletype))) ((sem_MaybeDeclarations (_where))))
sem_Declaration ((Declaration_Data (_range) (_context) (_simpletype) (_constructors) (_derivings))) =
    (sem_Declaration_Data ((sem_Range (_range))) ((sem_ContextItems (_context))) ((sem_SimpleType (_simpletype))) ((sem_Constructors (_constructors))) ((sem_Names (_derivings))))
sem_Declaration ((Declaration_Default (_range) (_types))) =
    (sem_Declaration_Default ((sem_Range (_range))) ((sem_Types (_types))))
sem_Declaration ((Declaration_Empty (_range))) =
    (sem_Declaration_Empty ((sem_Range (_range))))
sem_Declaration ((Declaration_Fixity (_range) (_fixity) (_priority) (_operators))) =
    (sem_Declaration_Fixity ((sem_Range (_range))) ((sem_Fixity (_fixity))) ((sem_MaybeInt (_priority))) ((sem_Names (_operators))))
sem_Declaration ((Declaration_FunctionBindings (_range) (_bindings))) =
    (sem_Declaration_FunctionBindings ((sem_Range (_range))) ((sem_FunctionBindings (_bindings))))
sem_Declaration ((Declaration_Instance (_range) (_context) (_name) (_types) (_where))) =
    (sem_Declaration_Instance ((sem_Range (_range))) ((sem_ContextItems (_context))) ((sem_Name (_name))) ((sem_Types (_types))) ((sem_MaybeDeclarations (_where))))
sem_Declaration ((Declaration_Newtype (_range) (_context) (_simpletype) (_constructor) (_derivings))) =
    (sem_Declaration_Newtype ((sem_Range (_range))) ((sem_ContextItems (_context))) ((sem_SimpleType (_simpletype))) ((sem_Constructor (_constructor))) ((sem_Names (_derivings))))
sem_Declaration ((Declaration_PatternBinding (_range) (_pattern) (_righthandside))) =
    (sem_Declaration_PatternBinding ((sem_Range (_range))) ((sem_Pattern (_pattern))) ((sem_RightHandSide (_righthandside))))
sem_Declaration ((Declaration_Type (_range) (_simpletype) (_type))) =
    (sem_Declaration_Type ((sem_Range (_range))) ((sem_SimpleType (_simpletype))) ((sem_Type (_type))))
sem_Declaration ((Declaration_TypeSignature (_range) (_names) (_type))) =
    (sem_Declaration_TypeSignature ((sem_Range (_range))) ((sem_Names (_names))) ((sem_Type (_type))))
sem_Declaration_Class :: (T_Range) ->
                         (T_ContextItems) ->
                         (T_SimpleType) ->
                         (T_MaybeDeclarations) ->
                         (T_Declaration)
sem_Declaration_Class (_range) (_context) (_simpletype) (_where) =
    let (_text) =
            text "{- !!! class decl -}"
        ( _range_text) =
            (_range )
        ( _context_text) =
            (_context )
        ( _simpletype_text) =
            (_simpletype )
        ( _where_text) =
            (_where )
    in  (_text)
sem_Declaration_Data :: (T_Range) ->
                        (T_ContextItems) ->
                        (T_SimpleType) ->
                        (T_Constructors) ->
                        (T_Names) ->
                        (T_Declaration)
sem_Declaration_Data (_range) (_context) (_simpletype) (_constructors) (_derivings) =
    let (_text) =
            text "data" <+>
            _contextDoc
            <>
            _simpletype_text
            <$>
            (indent 4 $
                vcat
                    (   text "="
                        <+>
                        head _constructors_text
                    :   map
                            (text "|" <+>)
                            (tail _constructors_text)
                    ++  [_derivingDoc]
                    )
            )
        (_contextDoc) =
            case _context_text of
             []  -> empty
             [x] -> x <+> text "=>" <+> empty
             xs  -> tupled xs <+> text "=>" <+> empty
        (_derivingDoc) =
            if null _derivings_text then
                empty
            else
                (    empty
                <+>  text "deriving"
                <+>  tupledUnit _derivings_text
                )
        ( _range_text) =
            (_range )
        ( _context_text) =
            (_context )
        ( _simpletype_text) =
            (_simpletype )
        ( _constructors_text) =
            (_constructors )
        ( _derivings_isIdentifier,_derivings_isOperator,_derivings_isSpecial,_derivings_text) =
            (_derivings )
    in  (_text)
sem_Declaration_Default :: (T_Range) ->
                           (T_Types) ->
                           (T_Declaration)
sem_Declaration_Default (_range) (_types) =
    let (_text) =
            text "default" <+> tupled _types_text
        ( _range_text) =
            (_range )
        ( _types_text) =
            (_types )
    in  (_text)
sem_Declaration_Empty :: (T_Range) ->
                         (T_Declaration)
sem_Declaration_Empty (_range) =
    let (_text) =
            empty
        ( _range_text) =
            (_range )
    in  (_text)
sem_Declaration_Fixity :: (T_Range) ->
                          (T_Fixity) ->
                          (T_MaybeInt) ->
                          (T_Names) ->
                          (T_Declaration)
sem_Declaration_Fixity (_range) (_fixity) (_priority) (_operators) =
    let (_text) =
            _fixity_text <+> _ops
        (_ops) =
            opt _priority_text <+>
                commas
                    (map
                        (\(n, p) -> if p then
                            text "`" <> n <> text "`"
                         else
                            n
                        )
                        (zip _operators_text _operators_isIdentifier)
                    )
        ( _range_text) =
            (_range )
        ( _fixity_text) =
            (_fixity )
        ( _priority_text) =
            (_priority )
        ( _operators_isIdentifier,_operators_isOperator,_operators_isSpecial,_operators_text) =
            (_operators )
    in  (_text)
sem_Declaration_FunctionBindings :: (T_Range) ->
                                    (T_FunctionBindings) ->
                                    (T_Declaration)
sem_Declaration_FunctionBindings (_range) (_bindings) =
    let (_text) =
            foldl1 (<$>) _bindings_text
        ( _range_text) =
            (_range )
        ( _bindings_text) =
            (_bindings )
    in  (_text)
sem_Declaration_Instance :: (T_Range) ->
                            (T_ContextItems) ->
                            (T_Name) ->
                            (T_Types) ->
                            (T_MaybeDeclarations) ->
                            (T_Declaration)
sem_Declaration_Instance (_range) (_context) (_name) (_types) (_where) =
    let (_text) =
            text "{- !!! instance decl -}"
        ( _range_text) =
            (_range )
        ( _context_text) =
            (_context )
        ( _name_isIdentifier,_name_isOperator,_name_isSpecial,_name_text) =
            (_name )
        ( _types_text) =
            (_types )
        ( _where_text) =
            (_where )
    in  (_text)
sem_Declaration_Newtype :: (T_Range) ->
                           (T_ContextItems) ->
                           (T_SimpleType) ->
                           (T_Constructor) ->
                           (T_Names) ->
                           (T_Declaration)
sem_Declaration_Newtype (_range) (_context) (_simpletype) (_constructor) (_derivings) =
    let (_text) =
            text "newtype"
            <+>
            _contextDoc
            <>
            _simpletype_text
            <+>
            _constructor_text
            <>
            _derivingDoc
        (_contextDoc) =
            case _context_text of
             []  -> empty
             [x] -> x <+> text "=>" <+> empty
             xs  -> tupled xs <+> text "=>" <+> empty
        (_derivingDoc) =
            if null _derivings_text then
                empty
            else
                (    empty
                <+>  text "deriving"
                <+>  tupledUnit _derivings_text
                )
        ( _range_text) =
            (_range )
        ( _context_text) =
            (_context )
        ( _simpletype_text) =
            (_simpletype )
        ( _constructor_text) =
            (_constructor )
        ( _derivings_isIdentifier,_derivings_isOperator,_derivings_isSpecial,_derivings_text) =
            (_derivings )
    in  (_text)
sem_Declaration_PatternBinding :: (T_Range) ->
                                  (T_Pattern) ->
                                  (T_RightHandSide) ->
                                  (T_Declaration)
sem_Declaration_PatternBinding (_range) (_pattern) (_righthandside) =
    let (_text) =
            _pattern_text <+> _righthandside_text (text "=")
        ( _range_text) =
            (_range )
        ( _pattern_text) =
            (_pattern )
        ( _righthandside_text) =
            (_righthandside )
    in  (_text)
sem_Declaration_Type :: (T_Range) ->
                        (T_SimpleType) ->
                        (T_Type) ->
                        (T_Declaration)
sem_Declaration_Type (_range) (_simpletype) (_type) =
    let (_text) =
            text "type" <+> _simpletype_text <+> text "=" <+> _type_text
        ( _range_text) =
            (_range )
        ( _simpletype_text) =
            (_simpletype )
        ( _type_text) =
            (_type )
    in  (_text)
sem_Declaration_TypeSignature :: (T_Range) ->
                                 (T_Names) ->
                                 (T_Type) ->
                                 (T_Declaration)
sem_Declaration_TypeSignature (_range) (_names) (_type) =
    let (_text) =
            commas _namesDocs <+> text "::" <+> _type_text
        (_namesDocs) =
            parensIfList _names_isOperator _names_text
        ( _range_text) =
            (_range )
        ( _names_isIdentifier,_names_isOperator,_names_isSpecial,_names_text) =
            (_names )
        ( _type_text) =
            (_type )
    in  (_text)
-- Declarations ------------------------------------------------
-- semantic domain
type T_Declarations = (( [       Doc ] ))
-- cata
sem_Declarations :: (Declarations) ->
                    (T_Declarations)
sem_Declarations (list) =
    (foldr (sem_Declarations_Cons) (sem_Declarations_Nil) ((map sem_Declaration list)))
sem_Declarations_Cons :: (T_Declaration) ->
                         (T_Declarations) ->
                         (T_Declarations)
sem_Declarations_Cons (_hd) (_tl) =
    let ( _hd_text) =
            (_hd )
        ( _tl_text) =
            (_tl )
    in  (_hd_text  :  _tl_text)
sem_Declarations_Nil :: (T_Declarations)
sem_Declarations_Nil  =
    let 
    in  ([])
-- Export ------------------------------------------------------
-- semantic domain
type T_Export = ((Doc))
-- cata
sem_Export :: (Export) ->
              (T_Export)
sem_Export ((Export_Module (_range) (_name))) =
    (sem_Export_Module ((sem_Range (_range))) ((sem_Name (_name))))
sem_Export ((Export_TypeOrClass (_range) (_name) (_names))) =
    (sem_Export_TypeOrClass ((sem_Range (_range))) ((sem_Name (_name))) ((sem_MaybeNames (_names))))
sem_Export ((Export_TypeOrClassComplete (_range) (_name))) =
    (sem_Export_TypeOrClassComplete ((sem_Range (_range))) ((sem_Name (_name))))
sem_Export ((Export_Variable (_range) (_name))) =
    (sem_Export_Variable ((sem_Range (_range))) ((sem_Name (_name))))
sem_Export_Module :: (T_Range) ->
                     (T_Name) ->
                     (T_Export)
sem_Export_Module (_range) (_name) =
    let (_text) =
            text "module" <+> _name_text
        ( _range_text) =
            (_range )
        ( _name_isIdentifier,_name_isOperator,_name_isSpecial,_name_text) =
            (_name )
    in  (_text)
sem_Export_TypeOrClass :: (T_Range) ->
                          (T_Name) ->
                          (T_MaybeNames) ->
                          (T_Export)
sem_Export_TypeOrClass (_range) (_name) (_names) =
    let (_text) =
            _name_text <> maybe empty tupled (_names_text)
        ( _range_text) =
            (_range )
        ( _name_isIdentifier,_name_isOperator,_name_isSpecial,_name_text) =
            (_name )
        ( _names_text) =
            (_names )
    in  (_text)
sem_Export_TypeOrClassComplete :: (T_Range) ->
                                  (T_Name) ->
                                  (T_Export)
sem_Export_TypeOrClassComplete (_range) (_name) =
    let (_text) =
            _name_text
        ( _range_text) =
            (_range )
        ( _name_isIdentifier,_name_isOperator,_name_isSpecial,_name_text) =
            (_name )
    in  (_text)
sem_Export_Variable :: (T_Range) ->
                       (T_Name) ->
                       (T_Export)
sem_Export_Variable (_range) (_name) =
    let (_text) =
            _name_text
        ( _range_text) =
            (_range )
        ( _name_isIdentifier,_name_isOperator,_name_isSpecial,_name_text) =
            (_name )
    in  (_text)
-- Exports -----------------------------------------------------
-- semantic domain
type T_Exports = (( [       Doc ] ))
-- cata
sem_Exports :: (Exports) ->
               (T_Exports)
sem_Exports (list) =
    (foldr (sem_Exports_Cons) (sem_Exports_Nil) ((map sem_Export list)))
sem_Exports_Cons :: (T_Export) ->
                    (T_Exports) ->
                    (T_Exports)
sem_Exports_Cons (_hd) (_tl) =
    let ( _hd_text) =
            (_hd )
        ( _tl_text) =
            (_tl )
    in  (_hd_text  :  _tl_text)
sem_Exports_Nil :: (T_Exports)
sem_Exports_Nil  =
    let 
    in  ([])
-- Expression --------------------------------------------------
-- semantic domain
type T_Expression = ((Doc))
-- cata
sem_Expression :: (Expression) ->
                  (T_Expression)
sem_Expression ((Expression_Case (_range) (_expression) (_alternatives))) =
    (sem_Expression_Case ((sem_Range (_range))) ((sem_Expression (_expression))) ((sem_Alternatives (_alternatives))))
sem_Expression ((Expression_Comprehension (_range) (_expression) (_qualifiers))) =
    (sem_Expression_Comprehension ((sem_Range (_range))) ((sem_Expression (_expression))) ((sem_Qualifiers (_qualifiers))))
sem_Expression ((Expression_Constructor (_range) (_name))) =
    (sem_Expression_Constructor ((sem_Range (_range))) ((sem_Name (_name))))
sem_Expression ((Expression_Do (_range) (_statements))) =
    (sem_Expression_Do ((sem_Range (_range))) ((sem_Statements (_statements))))
sem_Expression ((Expression_Enum (_range) (_from) (_then) (_to))) =
    (sem_Expression_Enum ((sem_Range (_range))) ((sem_Expression (_from))) ((sem_MaybeExpression (_then))) ((sem_MaybeExpression (_to))))
sem_Expression ((Expression_If (_range) (_guardExpression) (_thenExpression) (_elseExpression))) =
    (sem_Expression_If ((sem_Range (_range))) ((sem_Expression (_guardExpression))) ((sem_Expression (_thenExpression))) ((sem_Expression (_elseExpression))))
sem_Expression ((Expression_InfixApplication (_range) (_leftExpression) (_operator) (_rightExpression))) =
    (sem_Expression_InfixApplication ((sem_Range (_range))) ((sem_MaybeExpression (_leftExpression))) ((sem_Expression (_operator))) ((sem_MaybeExpression (_rightExpression))))
sem_Expression ((Expression_Lambda (_range) (_patterns) (_expression))) =
    (sem_Expression_Lambda ((sem_Range (_range))) ((sem_Patterns (_patterns))) ((sem_Expression (_expression))))
sem_Expression ((Expression_Let (_range) (_declarations) (_expression))) =
    (sem_Expression_Let ((sem_Range (_range))) ((sem_Declarations (_declarations))) ((sem_Expression (_expression))))
sem_Expression ((Expression_List (_range) (_expressions))) =
    (sem_Expression_List ((sem_Range (_range))) ((sem_Expressions (_expressions))))
sem_Expression ((Expression_Literal (_range) (_literal))) =
    (sem_Expression_Literal ((sem_Range (_range))) ((sem_Literal (_literal))))
sem_Expression ((Expression_Negate (_range) (_expression))) =
    (sem_Expression_Negate ((sem_Range (_range))) ((sem_Expression (_expression))))
sem_Expression ((Expression_NegateFloat (_range) (_expression))) =
    (sem_Expression_NegateFloat ((sem_Range (_range))) ((sem_Expression (_expression))))
sem_Expression ((Expression_NormalApplication (_range) (_function) (_arguments))) =
    (sem_Expression_NormalApplication ((sem_Range (_range))) ((sem_Expression (_function))) ((sem_Expressions (_arguments))))
sem_Expression ((Expression_Parenthesized (_range) (_expression))) =
    (sem_Expression_Parenthesized ((sem_Range (_range))) ((sem_Expression (_expression))))
sem_Expression ((Expression_RecordConstruction (_range) (_name) (_recordExpressionBindings))) =
    (sem_Expression_RecordConstruction ((sem_Range (_range))) ((sem_Name (_name))) ((sem_RecordExpressionBindings (_recordExpressionBindings))))
sem_Expression ((Expression_RecordUpdate (_range) (_expression) (_recordExpressionBindings))) =
    (sem_Expression_RecordUpdate ((sem_Range (_range))) ((sem_Expression (_expression))) ((sem_RecordExpressionBindings (_recordExpressionBindings))))
sem_Expression ((Expression_Tuple (_range) (_expressions))) =
    (sem_Expression_Tuple ((sem_Range (_range))) ((sem_Expressions (_expressions))))
sem_Expression ((Expression_Typed (_range) (_expression) (_type))) =
    (sem_Expression_Typed ((sem_Range (_range))) ((sem_Expression (_expression))) ((sem_Type (_type))))
sem_Expression ((Expression_Variable (_range) (_name))) =
    (sem_Expression_Variable ((sem_Range (_range))) ((sem_Name (_name))))
sem_Expression_Case :: (T_Range) ->
                       (T_Expression) ->
                       (T_Alternatives) ->
                       (T_Expression)
sem_Expression_Case (_range) (_expression) (_alternatives) =
    let (_text) =
            (text "case" <+> _expression_text <+> text "of" <$>
                           (indent 4 $ vcat _alternatives_text) <$> empty
                       )
        ( _range_text) =
            (_range )
        ( _expression_text) =
            (_expression )
        ( _alternatives_text) =
            (_alternatives )
    in  (_text)
sem_Expression_Comprehension :: (T_Range) ->
                                (T_Expression) ->
                                (T_Qualifiers) ->
                                (T_Expression)
sem_Expression_Comprehension (_range) (_expression) (_qualifiers) =
    let (_text) =
            text "[" <+> _expression_text <+>
            text "|" <+> commas _qualifiers_text <+> text "]"
        ( _range_text) =
            (_range )
        ( _expression_text) =
            (_expression )
        ( _qualifiers_text) =
            (_qualifiers )
    in  (_text)
sem_Expression_Constructor :: (T_Range) ->
                              (T_Name) ->
                              (T_Expression)
sem_Expression_Constructor (_range) (_name) =
    let (_text) =
            _name_text
        ( _range_text) =
            (_range )
        ( _name_isIdentifier,_name_isOperator,_name_isSpecial,_name_text) =
            (_name )
    in  (_text)
sem_Expression_Do :: (T_Range) ->
                     (T_Statements) ->
                     (T_Expression)
sem_Expression_Do (_range) (_statements) =
    let (_text) =
            text "do" <$> (indent 4 $ vcat _statements_text) <$> empty
        ( _range_text) =
            (_range )
        ( _statements_text) =
            (_statements )
    in  (_text)
sem_Expression_Enum :: (T_Range) ->
                       (T_Expression) ->
                       (T_MaybeExpression) ->
                       (T_MaybeExpression) ->
                       (T_Expression)
sem_Expression_Enum (_range) (_from) (_then) (_to) =
    let (_text) =
            text "[" <>
            _from_text <>
            maybe empty (text "," <+>)  _then_text <+>
            text ".." <+>
            opt _to_text <>
            text "]"
        ( _range_text) =
            (_range )
        ( _from_text) =
            (_from )
        ( _then_text) =
            (_then )
        ( _to_text) =
            (_to )
    in  (_text)
sem_Expression_If :: (T_Range) ->
                     (T_Expression) ->
                     (T_Expression) ->
                     (T_Expression) ->
                     (T_Expression)
sem_Expression_If (_range) (_guardExpression) (_thenExpression) (_elseExpression) =
    let (_text) =
            text "if" <+> _guardExpression_text <+> text "then" <$>
                           indent 4 _thenExpression_text <$>
                       text "else" <$>
                           indent 4 _elseExpression_text <$> empty
        ( _range_text) =
            (_range )
        ( _guardExpression_text) =
            (_guardExpression )
        ( _thenExpression_text) =
            (_thenExpression )
        ( _elseExpression_text) =
            (_elseExpression )
    in  (_text)
sem_Expression_InfixApplication :: (T_Range) ->
                                   (T_MaybeExpression) ->
                                   (T_Expression) ->
                                   (T_MaybeExpression) ->
                                   (T_Expression)
sem_Expression_InfixApplication (_range) (_leftExpression) (_operator) (_rightExpression) =
    let (_text) =
            let f []       m = m
                f n@(c:cs) m = if isAlpha c && all (\c -> c == '_' || c == '\'' || isAlphaNum c) cs then char '`' <> m <> char '`' else m
            in
               case (_leftExpression_text, _rightExpression_text) of
                   (Nothing, Nothing) ->
                       parens _operator_text
                   (Just l , Nothing) ->
                       parens (l <+> _operator_text)
                   (Nothing, Just r ) ->
                       parens (_operator_text <+> r)
                   (Just l , Just r ) ->
                       l
                       <+>
                       f (show _operator_text) _operator_text
                       <+>
                       r
        ( _range_text) =
            (_range )
        ( _leftExpression_text) =
            (_leftExpression )
        ( _operator_text) =
            (_operator )
        ( _rightExpression_text) =
            (_rightExpression )
    in  (_text)
sem_Expression_Lambda :: (T_Range) ->
                         (T_Patterns) ->
                         (T_Expression) ->
                         (T_Expression)
sem_Expression_Lambda (_range) (_patterns) (_expression) =
    let (_text) =
            text "\\" <+> foldl1 (<+>) _patterns_text <+> text "->" <+> _expression_text
        ( _range_text) =
            (_range )
        ( _patterns_text) =
            (_patterns )
        ( _expression_text) =
            (_expression )
    in  (_text)
sem_Expression_Let :: (T_Range) ->
                      (T_Declarations) ->
                      (T_Expression) ->
                      (T_Expression)
sem_Expression_Let (_range) (_declarations) (_expression) =
    let (_text) =
            (text "let"<$>
                           (indent 4 $ vcat _declarations_text) <$>
                        text "in" <$>
                           (indent 4 $ _expression_text)
                       ) <$> empty
        ( _range_text) =
            (_range )
        ( _declarations_text) =
            (_declarations )
        ( _expression_text) =
            (_expression )
    in  (_text)
sem_Expression_List :: (T_Range) ->
                       (T_Expressions) ->
                       (T_Expression)
sem_Expression_List (_range) (_expressions) =
    let (_text) =
            list _expressions_text
        ( _range_text) =
            (_range )
        ( _expressions_text) =
            (_expressions )
    in  (_text)
sem_Expression_Literal :: (T_Range) ->
                          (T_Literal) ->
                          (T_Expression)
sem_Expression_Literal (_range) (_literal) =
    let (_text) =
            _literal_text
        ( _range_text) =
            (_range )
        ( _literal_text) =
            (_literal )
    in  (_text)
sem_Expression_Negate :: (T_Range) ->
                         (T_Expression) ->
                         (T_Expression)
sem_Expression_Negate (_range) (_expression) =
    let (_text) =
            text "-" <> parens (_expression_text)
        ( _range_text) =
            (_range )
        ( _expression_text) =
            (_expression )
    in  (_text)
sem_Expression_NegateFloat :: (T_Range) ->
                              (T_Expression) ->
                              (T_Expression)
sem_Expression_NegateFloat (_range) (_expression) =
    let (_text) =
            text "-." <> parens (_expression_text)
        ( _range_text) =
            (_range )
        ( _expression_text) =
            (_expression )
    in  (_text)
sem_Expression_NormalApplication :: (T_Range) ->
                                    (T_Expression) ->
                                    (T_Expressions) ->
                                    (T_Expression)
sem_Expression_NormalApplication (_range) (_function) (_arguments) =
    let (_text) =
            foldl (<+>) _function_text _arguments_text
        ( _range_text) =
            (_range )
        ( _function_text) =
            (_function )
        ( _arguments_text) =
            (_arguments )
    in  (_text)
sem_Expression_Parenthesized :: (T_Range) ->
                                (T_Expression) ->
                                (T_Expression)
sem_Expression_Parenthesized (_range) (_expression) =
    let (_text) =
            parens _expression_text
        ( _range_text) =
            (_range )
        ( _expression_text) =
            (_expression )
    in  (_text)
sem_Expression_RecordConstruction :: (T_Range) ->
                                     (T_Name) ->
                                     (T_RecordExpressionBindings) ->
                                     (T_Expression)
sem_Expression_RecordConstruction (_range) (_name) (_recordExpressionBindings) =
    let (_text) =
            intErr "Expression" "record construction"
        ( _range_text) =
            (_range )
        ( _name_isIdentifier,_name_isOperator,_name_isSpecial,_name_text) =
            (_name )
        ( _recordExpressionBindings_text) =
            (_recordExpressionBindings )
    in  (_text)
sem_Expression_RecordUpdate :: (T_Range) ->
                               (T_Expression) ->
                               (T_RecordExpressionBindings) ->
                               (T_Expression)
sem_Expression_RecordUpdate (_range) (_expression) (_recordExpressionBindings) =
    let (_text) =
            intErr "Expression" "record update"
        ( _range_text) =
            (_range )
        ( _expression_text) =
            (_expression )
        ( _recordExpressionBindings_text) =
            (_recordExpressionBindings )
    in  (_text)
sem_Expression_Tuple :: (T_Range) ->
                        (T_Expressions) ->
                        (T_Expression)
sem_Expression_Tuple (_range) (_expressions) =
    let (_text) =
            tupled _expressions_text
        ( _range_text) =
            (_range )
        ( _expressions_text) =
            (_expressions )
    in  (_text)
sem_Expression_Typed :: (T_Range) ->
                        (T_Expression) ->
                        (T_Type) ->
                        (T_Expression)
sem_Expression_Typed (_range) (_expression) (_type) =
    let (_text) =
            _expression_text <+> text "::" <+> _type_text
        ( _range_text) =
            (_range )
        ( _expression_text) =
            (_expression )
        ( _type_text) =
            (_type )
    in  (_text)
sem_Expression_Variable :: (T_Range) ->
                           (T_Name) ->
                           (T_Expression)
sem_Expression_Variable (_range) (_name) =
    let (_text) =
            _name_text
        ( _range_text) =
            (_range )
        ( _name_isIdentifier,_name_isOperator,_name_isSpecial,_name_text) =
            (_name )
    in  (_text)
-- Expressions -------------------------------------------------
-- semantic domain
type T_Expressions = (( [       Doc ] ))
-- cata
sem_Expressions :: (Expressions) ->
                   (T_Expressions)
sem_Expressions (list) =
    (foldr (sem_Expressions_Cons) (sem_Expressions_Nil) ((map sem_Expression list)))
sem_Expressions_Cons :: (T_Expression) ->
                        (T_Expressions) ->
                        (T_Expressions)
sem_Expressions_Cons (_hd) (_tl) =
    let ( _hd_text) =
            (_hd )
        ( _tl_text) =
            (_tl )
    in  (_hd_text  :  _tl_text)
sem_Expressions_Nil :: (T_Expressions)
sem_Expressions_Nil  =
    let 
    in  ([])
-- FieldDeclaration --------------------------------------------
-- semantic domain
type T_FieldDeclaration = ((Doc))
-- cata
sem_FieldDeclaration :: (FieldDeclaration) ->
                        (T_FieldDeclaration)
sem_FieldDeclaration ((FieldDeclaration_FieldDeclaration (_range) (_names) (_type))) =
    (sem_FieldDeclaration_FieldDeclaration ((sem_Range (_range))) ((sem_Names (_names))) ((sem_AnnotatedType (_type))))
sem_FieldDeclaration_FieldDeclaration :: (T_Range) ->
                                         (T_Names) ->
                                         (T_AnnotatedType) ->
                                         (T_FieldDeclaration)
sem_FieldDeclaration_FieldDeclaration (_range) (_names) (_type) =
    let (_text) =
            text "{- !!! field declaration -}"
        ( _range_text) =
            (_range )
        ( _names_isIdentifier,_names_isOperator,_names_isSpecial,_names_text) =
            (_names )
        ( _type_text) =
            (_type )
    in  (_text)
-- FieldDeclarations -------------------------------------------
-- semantic domain
type T_FieldDeclarations = (( [       Doc ] ))
-- cata
sem_FieldDeclarations :: (FieldDeclarations) ->
                         (T_FieldDeclarations)
sem_FieldDeclarations (list) =
    (foldr (sem_FieldDeclarations_Cons) (sem_FieldDeclarations_Nil) ((map sem_FieldDeclaration list)))
sem_FieldDeclarations_Cons :: (T_FieldDeclaration) ->
                              (T_FieldDeclarations) ->
                              (T_FieldDeclarations)
sem_FieldDeclarations_Cons (_hd) (_tl) =
    let ( _hd_text) =
            (_hd )
        ( _tl_text) =
            (_tl )
    in  (_hd_text  :  _tl_text)
sem_FieldDeclarations_Nil :: (T_FieldDeclarations)
sem_FieldDeclarations_Nil  =
    let 
    in  ([])
-- Fixity ------------------------------------------------------
-- semantic domain
type T_Fixity = ((Doc))
-- cata
sem_Fixity :: (Fixity) ->
              (T_Fixity)
sem_Fixity ((Fixity_Infix (_range))) =
    (sem_Fixity_Infix ((sem_Range (_range))))
sem_Fixity ((Fixity_Infixl (_range))) =
    (sem_Fixity_Infixl ((sem_Range (_range))))
sem_Fixity ((Fixity_Infixr (_range))) =
    (sem_Fixity_Infixr ((sem_Range (_range))))
sem_Fixity_Infix :: (T_Range) ->
                    (T_Fixity)
sem_Fixity_Infix (_range) =
    let (_text) =
            text "infix "
        ( _range_text) =
            (_range )
    in  (_text)
sem_Fixity_Infixl :: (T_Range) ->
                     (T_Fixity)
sem_Fixity_Infixl (_range) =
    let (_text) =
            text "infixl"
        ( _range_text) =
            (_range )
    in  (_text)
sem_Fixity_Infixr :: (T_Range) ->
                     (T_Fixity)
sem_Fixity_Infixr (_range) =
    let (_text) =
            text "infixr"
        ( _range_text) =
            (_range )
    in  (_text)
-- FunctionBinding ---------------------------------------------
-- semantic domain
type T_FunctionBinding = ((Doc))
-- cata
sem_FunctionBinding :: (FunctionBinding) ->
                       (T_FunctionBinding)
sem_FunctionBinding ((FunctionBinding_FunctionBinding (_range) (_lefthandside) (_righthandside))) =
    (sem_FunctionBinding_FunctionBinding ((sem_Range (_range))) ((sem_LeftHandSide (_lefthandside))) ((sem_RightHandSide (_righthandside))))
sem_FunctionBinding_FunctionBinding :: (T_Range) ->
                                       (T_LeftHandSide) ->
                                       (T_RightHandSide) ->
                                       (T_FunctionBinding)
sem_FunctionBinding_FunctionBinding (_range) (_lefthandside) (_righthandside) =
    let (_text) =
            _lefthandside_text <+> _righthandside_text (text "=")
        ( _range_text) =
            (_range )
        ( _lefthandside_text) =
            (_lefthandside )
        ( _righthandside_text) =
            (_righthandside )
    in  (_text)
-- FunctionBindings --------------------------------------------
-- semantic domain
type T_FunctionBindings = (( [       Doc ] ))
-- cata
sem_FunctionBindings :: (FunctionBindings) ->
                        (T_FunctionBindings)
sem_FunctionBindings (list) =
    (foldr (sem_FunctionBindings_Cons) (sem_FunctionBindings_Nil) ((map sem_FunctionBinding list)))
sem_FunctionBindings_Cons :: (T_FunctionBinding) ->
                             (T_FunctionBindings) ->
                             (T_FunctionBindings)
sem_FunctionBindings_Cons (_hd) (_tl) =
    let ( _hd_text) =
            (_hd )
        ( _tl_text) =
            (_tl )
    in  (_hd_text  :  _tl_text)
sem_FunctionBindings_Nil :: (T_FunctionBindings)
sem_FunctionBindings_Nil  =
    let 
    in  ([])
-- GuardedExpression -------------------------------------------
-- semantic domain
type T_GuardedExpression = (( Doc        -> Doc  ))
-- cata
sem_GuardedExpression :: (GuardedExpression) ->
                         (T_GuardedExpression)
sem_GuardedExpression ((GuardedExpression_GuardedExpression (_range) (_guard) (_expression))) =
    (sem_GuardedExpression_GuardedExpression ((sem_Range (_range))) ((sem_Expression (_guard))) ((sem_Expression (_expression))))
sem_GuardedExpression_GuardedExpression :: (T_Range) ->
                                           (T_Expression) ->
                                           (T_Expression) ->
                                           (T_GuardedExpression)
sem_GuardedExpression_GuardedExpression (_range) (_guard) (_expression) =
    let (_text) =
            \assign -> text "|" <+> _guard_text <+> assign <+> _expression_text
        ( _range_text) =
            (_range )
        ( _guard_text) =
            (_guard )
        ( _expression_text) =
            (_expression )
    in  (_text)
-- GuardedExpressions ------------------------------------------
-- semantic domain
type T_GuardedExpressions = (( [        Doc -> Doc  ] ))
-- cata
sem_GuardedExpressions :: (GuardedExpressions) ->
                          (T_GuardedExpressions)
sem_GuardedExpressions (list) =
    (foldr (sem_GuardedExpressions_Cons) (sem_GuardedExpressions_Nil) ((map sem_GuardedExpression list)))
sem_GuardedExpressions_Cons :: (T_GuardedExpression) ->
                               (T_GuardedExpressions) ->
                               (T_GuardedExpressions)
sem_GuardedExpressions_Cons (_hd) (_tl) =
    let ( _hd_text) =
            (_hd )
        ( _tl_text) =
            (_tl )
    in  (_hd_text  :  _tl_text)
sem_GuardedExpressions_Nil :: (T_GuardedExpressions)
sem_GuardedExpressions_Nil  =
    let 
    in  ([])
-- Import ------------------------------------------------------
-- semantic domain
type T_Import = ((Doc))
-- cata
sem_Import :: (Import) ->
              (T_Import)
sem_Import ((Import_TypeOrClass (_range) (_name) (_names))) =
    (sem_Import_TypeOrClass ((sem_Range (_range))) ((sem_Name (_name))) ((sem_MaybeNames (_names))))
sem_Import ((Import_TypeOrClassComplete (_range) (_name))) =
    (sem_Import_TypeOrClassComplete ((sem_Range (_range))) ((sem_Name (_name))))
sem_Import ((Import_Variable (_range) (_name))) =
    (sem_Import_Variable ((sem_Range (_range))) ((sem_Name (_name))))
sem_Import_TypeOrClass :: (T_Range) ->
                          (T_Name) ->
                          (T_MaybeNames) ->
                          (T_Import)
sem_Import_TypeOrClass (_range) (_name) (_names) =
    let (_text) =
            _name_text <> maybe empty tupled1 _names_text
        ( _range_text) =
            (_range )
        ( _name_isIdentifier,_name_isOperator,_name_isSpecial,_name_text) =
            (_name )
        ( _names_text) =
            (_names )
    in  (_text)
sem_Import_TypeOrClassComplete :: (T_Range) ->
                                  (T_Name) ->
                                  (T_Import)
sem_Import_TypeOrClassComplete (_range) (_name) =
    let (_text) =
            _name_text
        ( _range_text) =
            (_range )
        ( _name_isIdentifier,_name_isOperator,_name_isSpecial,_name_text) =
            (_name )
    in  (_text)
sem_Import_Variable :: (T_Range) ->
                       (T_Name) ->
                       (T_Import)
sem_Import_Variable (_range) (_name) =
    let (_text) =
            _name_text
        ( _range_text) =
            (_range )
        ( _name_isIdentifier,_name_isOperator,_name_isSpecial,_name_text) =
            (_name )
    in  (_text)
-- ImportDeclaration -------------------------------------------
-- semantic domain
type T_ImportDeclaration = ((Doc))
-- cata
sem_ImportDeclaration :: (ImportDeclaration) ->
                         (T_ImportDeclaration)
sem_ImportDeclaration ((ImportDeclaration_Empty (_range))) =
    (sem_ImportDeclaration_Empty ((sem_Range (_range))))
sem_ImportDeclaration ((ImportDeclaration_Import (_range) (_qualified) (_name) (_asname) (_importspecification))) =
    (sem_ImportDeclaration_Import ((sem_Range (_range))) (_qualified) ((sem_Name (_name))) ((sem_MaybeName (_asname))) ((sem_MaybeImportSpecification (_importspecification))))
sem_ImportDeclaration_Empty :: (T_Range) ->
                               (T_ImportDeclaration)
sem_ImportDeclaration_Empty (_range) =
    let (_text) =
            empty
        ( _range_text) =
            (_range )
    in  (_text)
sem_ImportDeclaration_Import :: (T_Range) ->
                                (Bool) ->
                                (T_Name) ->
                                (T_MaybeName) ->
                                (T_MaybeImportSpecification) ->
                                (T_ImportDeclaration)
sem_ImportDeclaration_Import (_range) (_qualified) (_name) (_asname) (_importspecification) =
    let (_text) =
            text "import" <+> (if _qualified then (text "qualified" <+>) else id) _name_text <+> maybe empty id _importspecification_text
        ( _range_text) =
            (_range )
        ( _name_isIdentifier,_name_isOperator,_name_isSpecial,_name_text) =
            (_name )
        ( _asname_text) =
            (_asname )
        ( _importspecification_text) =
            (_importspecification )
    in  (_text)
-- ImportDeclarations ------------------------------------------
-- semantic domain
type T_ImportDeclarations = (( [       Doc ] ))
-- cata
sem_ImportDeclarations :: (ImportDeclarations) ->
                          (T_ImportDeclarations)
sem_ImportDeclarations (list) =
    (foldr (sem_ImportDeclarations_Cons) (sem_ImportDeclarations_Nil) ((map sem_ImportDeclaration list)))
sem_ImportDeclarations_Cons :: (T_ImportDeclaration) ->
                               (T_ImportDeclarations) ->
                               (T_ImportDeclarations)
sem_ImportDeclarations_Cons (_hd) (_tl) =
    let ( _hd_text) =
            (_hd )
        ( _tl_text) =
            (_tl )
    in  (_hd_text  :  _tl_text)
sem_ImportDeclarations_Nil :: (T_ImportDeclarations)
sem_ImportDeclarations_Nil  =
    let 
    in  ([])
-- ImportSpecification -----------------------------------------
-- semantic domain
type T_ImportSpecification = ((Doc))
-- cata
sem_ImportSpecification :: (ImportSpecification) ->
                           (T_ImportSpecification)
sem_ImportSpecification ((ImportSpecification_Import (_range) (_hiding) (_imports))) =
    (sem_ImportSpecification_Import ((sem_Range (_range))) (_hiding) ((sem_Imports (_imports))))
sem_ImportSpecification_Import :: (T_Range) ->
                                  (Bool) ->
                                  (T_Imports) ->
                                  (T_ImportSpecification)
sem_ImportSpecification_Import (_range) (_hiding) (_imports) =
    let (_text) =
            (if _hiding then (text "hiding" <+>) else id)
                                     (tupled _imports_text)
        ( _range_text) =
            (_range )
        ( _imports_text) =
            (_imports )
    in  (_text)
-- Imports -----------------------------------------------------
-- semantic domain
type T_Imports = (( [       Doc ] ))
-- cata
sem_Imports :: (Imports) ->
               (T_Imports)
sem_Imports (list) =
    (foldr (sem_Imports_Cons) (sem_Imports_Nil) ((map sem_Import list)))
sem_Imports_Cons :: (T_Import) ->
                    (T_Imports) ->
                    (T_Imports)
sem_Imports_Cons (_hd) (_tl) =
    let ( _hd_text) =
            (_hd )
        ( _tl_text) =
            (_tl )
    in  (_hd_text  :  _tl_text)
sem_Imports_Nil :: (T_Imports)
sem_Imports_Nil  =
    let 
    in  ([])
-- LeftHandSide ------------------------------------------------
-- semantic domain
type T_LeftHandSide = ((Doc))
-- cata
sem_LeftHandSide :: (LeftHandSide) ->
                    (T_LeftHandSide)
sem_LeftHandSide ((LeftHandSide_Function (_range) (_name) (_patterns))) =
    (sem_LeftHandSide_Function ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Patterns (_patterns))))
sem_LeftHandSide ((LeftHandSide_Infix (_range) (_leftPattern) (_operator) (_rightPattern))) =
    (sem_LeftHandSide_Infix ((sem_Range (_range))) ((sem_Pattern (_leftPattern))) ((sem_Name (_operator))) ((sem_Pattern (_rightPattern))))
sem_LeftHandSide ((LeftHandSide_Parenthesized (_range) (_lefthandside) (_patterns))) =
    (sem_LeftHandSide_Parenthesized ((sem_Range (_range))) ((sem_LeftHandSide (_lefthandside))) ((sem_Patterns (_patterns))))
sem_LeftHandSide_Function :: (T_Range) ->
                             (T_Name) ->
                             (T_Patterns) ->
                             (T_LeftHandSide)
sem_LeftHandSide_Function (_range) (_name) (_patterns) =
    let (_text) =
            foldl (<+>) _name_text _patterns_text
        ( _range_text) =
            (_range )
        ( _name_isIdentifier,_name_isOperator,_name_isSpecial,_name_text) =
            (_name )
        ( _patterns_text) =
            (_patterns )
    in  (_text)
sem_LeftHandSide_Infix :: (T_Range) ->
                          (T_Pattern) ->
                          (T_Name) ->
                          (T_Pattern) ->
                          (T_LeftHandSide)
sem_LeftHandSide_Infix (_range) (_leftPattern) (_operator) (_rightPattern) =
    let (_text) =
            _leftPattern_text <+> _operator_text <+> _rightPattern_text
        ( _range_text) =
            (_range )
        ( _leftPattern_text) =
            (_leftPattern )
        ( _operator_isIdentifier,_operator_isOperator,_operator_isSpecial,_operator_text) =
            (_operator )
        ( _rightPattern_text) =
            (_rightPattern )
    in  (_text)
sem_LeftHandSide_Parenthesized :: (T_Range) ->
                                  (T_LeftHandSide) ->
                                  (T_Patterns) ->
                                  (T_LeftHandSide)
sem_LeftHandSide_Parenthesized (_range) (_lefthandside) (_patterns) =
    let (_text) =
            foldl (<+>) (parens _lefthandside_text) _patterns_text
        ( _range_text) =
            (_range )
        ( _lefthandside_text) =
            (_lefthandside )
        ( _patterns_text) =
            (_patterns )
    in  (_text)
-- Literal -----------------------------------------------------
-- semantic domain
type T_Literal = ((Doc))
-- cata
sem_Literal :: (Literal) ->
               (T_Literal)
sem_Literal ((Literal_Char (_range) (_value))) =
    (sem_Literal_Char ((sem_Range (_range))) (_value))
sem_Literal ((Literal_Float (_range) (_value))) =
    (sem_Literal_Float ((sem_Range (_range))) (_value))
sem_Literal ((Literal_Int (_range) (_value))) =
    (sem_Literal_Int ((sem_Range (_range))) (_value))
sem_Literal ((Literal_String (_range) (_value))) =
    (sem_Literal_String ((sem_Range (_range))) (_value))
sem_Literal_Char :: (T_Range) ->
                    (String) ->
                    (T_Literal)
sem_Literal_Char (_range) (_value) =
    let (_text) =
            text ("'" ++ _value ++ "'")
        ( _range_text) =
            (_range )
    in  (_text)
sem_Literal_Float :: (T_Range) ->
                     (String) ->
                     (T_Literal)
sem_Literal_Float (_range) (_value) =
    let (_text) =
            text _value
        ( _range_text) =
            (_range )
    in  (_text)
sem_Literal_Int :: (T_Range) ->
                   (String) ->
                   (T_Literal)
sem_Literal_Int (_range) (_value) =
    let (_text) =
            text _value
        ( _range_text) =
            (_range )
    in  (_text)
sem_Literal_String :: (T_Range) ->
                      (String) ->
                      (T_Literal)
sem_Literal_String (_range) (_value) =
    let (_text) =
            text ("\"" ++ _value ++ "\"")
        ( _range_text) =
            (_range )
    in  (_text)
-- MaybeDeclarations -------------------------------------------
-- semantic domain
type T_MaybeDeclarations = (( Maybe [       Doc ] ))
-- cata
sem_MaybeDeclarations :: (MaybeDeclarations) ->
                         (T_MaybeDeclarations)
sem_MaybeDeclarations ((MaybeDeclarations_Just (_declarations))) =
    (sem_MaybeDeclarations_Just ((sem_Declarations (_declarations))))
sem_MaybeDeclarations ((MaybeDeclarations_Nothing )) =
    (sem_MaybeDeclarations_Nothing )
sem_MaybeDeclarations_Just :: (T_Declarations) ->
                              (T_MaybeDeclarations)
sem_MaybeDeclarations_Just (_declarations) =
    let (_text) =
            Just _declarations_text
        ( _declarations_text) =
            (_declarations )
    in  (_text)
sem_MaybeDeclarations_Nothing :: (T_MaybeDeclarations)
sem_MaybeDeclarations_Nothing  =
    let (_text) =
            Nothing
    in  (_text)
-- MaybeExports ------------------------------------------------
-- semantic domain
type T_MaybeExports = (( Maybe [       Doc ] ))
-- cata
sem_MaybeExports :: (MaybeExports) ->
                    (T_MaybeExports)
sem_MaybeExports ((MaybeExports_Just (_exports))) =
    (sem_MaybeExports_Just ((sem_Exports (_exports))))
sem_MaybeExports ((MaybeExports_Nothing )) =
    (sem_MaybeExports_Nothing )
sem_MaybeExports_Just :: (T_Exports) ->
                         (T_MaybeExports)
sem_MaybeExports_Just (_exports) =
    let (_text) =
            Just _exports_text
        ( _exports_text) =
            (_exports )
    in  (_text)
sem_MaybeExports_Nothing :: (T_MaybeExports)
sem_MaybeExports_Nothing  =
    let (_text) =
            Nothing
    in  (_text)
-- MaybeExpression ---------------------------------------------
-- semantic domain
type T_MaybeExpression = ((        Maybe Doc  ))
-- cata
sem_MaybeExpression :: (MaybeExpression) ->
                       (T_MaybeExpression)
sem_MaybeExpression ((MaybeExpression_Just (_expression))) =
    (sem_MaybeExpression_Just ((sem_Expression (_expression))))
sem_MaybeExpression ((MaybeExpression_Nothing )) =
    (sem_MaybeExpression_Nothing )
sem_MaybeExpression_Just :: (T_Expression) ->
                            (T_MaybeExpression)
sem_MaybeExpression_Just (_expression) =
    let (_text) =
            Just _expression_text
        ( _expression_text) =
            (_expression )
    in  (_text)
sem_MaybeExpression_Nothing :: (T_MaybeExpression)
sem_MaybeExpression_Nothing  =
    let (_text) =
            Nothing
    in  (_text)
-- MaybeImportSpecification ------------------------------------
-- semantic domain
type T_MaybeImportSpecification = ((        Maybe Doc  ))
-- cata
sem_MaybeImportSpecification :: (MaybeImportSpecification) ->
                                (T_MaybeImportSpecification)
sem_MaybeImportSpecification ((MaybeImportSpecification_Just (_importspecification))) =
    (sem_MaybeImportSpecification_Just ((sem_ImportSpecification (_importspecification))))
sem_MaybeImportSpecification ((MaybeImportSpecification_Nothing )) =
    (sem_MaybeImportSpecification_Nothing )
sem_MaybeImportSpecification_Just :: (T_ImportSpecification) ->
                                     (T_MaybeImportSpecification)
sem_MaybeImportSpecification_Just (_importspecification) =
    let (_text) =
            Just _importspecification_text
        ( _importspecification_text) =
            (_importspecification )
    in  (_text)
sem_MaybeImportSpecification_Nothing :: (T_MaybeImportSpecification)
sem_MaybeImportSpecification_Nothing  =
    let (_text) =
            Nothing
    in  (_text)
-- MaybeInt ----------------------------------------------------
-- semantic domain
type T_MaybeInt = ((        Maybe Doc  ))
-- cata
sem_MaybeInt :: (MaybeInt) ->
                (T_MaybeInt)
sem_MaybeInt ((MaybeInt_Just (_int))) =
    (sem_MaybeInt_Just (_int))
sem_MaybeInt ((MaybeInt_Nothing )) =
    (sem_MaybeInt_Nothing )
sem_MaybeInt_Just :: (Int) ->
                     (T_MaybeInt)
sem_MaybeInt_Just (_int) =
    let (_text) =
            Just (int _int)
    in  (_text)
sem_MaybeInt_Nothing :: (T_MaybeInt)
sem_MaybeInt_Nothing  =
    let (_text) =
            Nothing
    in  (_text)
-- MaybeName ---------------------------------------------------
-- semantic domain
type T_MaybeName = ((        Maybe Doc  ))
-- cata
sem_MaybeName :: (MaybeName) ->
                 (T_MaybeName)
sem_MaybeName ((MaybeName_Just (_name))) =
    (sem_MaybeName_Just ((sem_Name (_name))))
sem_MaybeName ((MaybeName_Nothing )) =
    (sem_MaybeName_Nothing )
sem_MaybeName_Just :: (T_Name) ->
                      (T_MaybeName)
sem_MaybeName_Just (_name) =
    let (_text) =
            Just _name_text
        ( _name_isIdentifier,_name_isOperator,_name_isSpecial,_name_text) =
            (_name )
    in  (_text)
sem_MaybeName_Nothing :: (T_MaybeName)
sem_MaybeName_Nothing  =
    let (_text) =
            Nothing
    in  (_text)
-- MaybeNames --------------------------------------------------
-- semantic domain
type T_MaybeNames = (( Maybe [       Doc ] ))
-- cata
sem_MaybeNames :: (MaybeNames) ->
                  (T_MaybeNames)
sem_MaybeNames ((MaybeNames_Just (_names))) =
    (sem_MaybeNames_Just ((sem_Names (_names))))
sem_MaybeNames ((MaybeNames_Nothing )) =
    (sem_MaybeNames_Nothing )
sem_MaybeNames_Just :: (T_Names) ->
                       (T_MaybeNames)
sem_MaybeNames_Just (_names) =
    let (_text) =
            Just _names_text
        ( _names_isIdentifier,_names_isOperator,_names_isSpecial,_names_text) =
            (_names )
    in  (_text)
sem_MaybeNames_Nothing :: (T_MaybeNames)
sem_MaybeNames_Nothing  =
    let (_text) =
            Nothing
    in  (_text)
-- Module ------------------------------------------------------
-- semantic domain
type T_Module = ((Doc))
-- cata
sem_Module :: (Module) ->
              (T_Module)
sem_Module ((Module_Module (_range) (_name) (_exports) (_body))) =
    (sem_Module_Module ((sem_Range (_range))) ((sem_MaybeName (_name))) ((sem_MaybeExports (_exports))) ((sem_Body (_body))))
sem_Module_Module :: (T_Range) ->
                     (T_MaybeName) ->
                     (T_MaybeExports) ->
                     (T_Body) ->
                     (T_Module)
sem_Module_Module (_range) (_name) (_exports) (_body) =
    let (_text) =
            maybe
                id
                ( \name body ->
                    text "module" <+> name <+>
                        (maybe
                            (text "where")
                            (\x -> indent 4 (utrechtList (text "(") (text ")") x <+> text "where"))
                            _exports_text
                        )
                    <$> empty <$>
                    body
                )
                _name_text
                _body_text
        ( _range_text) =
            (_range )
        ( _name_text) =
            (_name )
        ( _exports_text) =
            (_exports )
        ( _body_text) =
            (_body )
    in  (_text)
-- Name --------------------------------------------------------
-- semantic domain
type T_Name = ((Bool),(Bool),(Bool),(Doc))
-- cata
sem_Name :: (Name) ->
            (T_Name)
sem_Name ((Name_Identifier (_range) (_module) (_name))) =
    (sem_Name_Identifier ((sem_Range (_range))) ((sem_Strings (_module))) (_name))
sem_Name ((Name_Operator (_range) (_module) (_name))) =
    (sem_Name_Operator ((sem_Range (_range))) ((sem_Strings (_module))) (_name))
sem_Name ((Name_Special (_range) (_module) (_name))) =
    (sem_Name_Special ((sem_Range (_range))) ((sem_Strings (_module))) (_name))
sem_Name_Identifier :: (T_Range) ->
                       (T_Strings) ->
                       (String) ->
                       (T_Name)
sem_Name_Identifier (_range) (_module) (_name) =
    let (_text) =
            text _name
        ( _range_text) =
            (_range )
        ( _module_text) =
            (_module )
    in  (True,False,False,_text)
sem_Name_Operator :: (T_Range) ->
                     (T_Strings) ->
                     (String) ->
                     (T_Name)
sem_Name_Operator (_range) (_module) (_name) =
    let (_text) =
            text _name
        ( _range_text) =
            (_range )
        ( _module_text) =
            (_module )
    in  (False,True,False,_text)
sem_Name_Special :: (T_Range) ->
                    (T_Strings) ->
                    (String) ->
                    (T_Name)
sem_Name_Special (_range) (_module) (_name) =
    let (_text) =
            text _name
        ( _range_text) =
            (_range )
        ( _module_text) =
            (_module )
    in  (False,False,True,_text)
-- Names -------------------------------------------------------
-- semantic domain
type T_Names = (( [Bool] ),( [Bool] ),( [Bool] ),( [       Doc ] ))
-- cata
sem_Names :: (Names) ->
             (T_Names)
sem_Names (list) =
    (foldr (sem_Names_Cons) (sem_Names_Nil) ((map sem_Name list)))
sem_Names_Cons :: (T_Name) ->
                  (T_Names) ->
                  (T_Names)
sem_Names_Cons (_hd) (_tl) =
    let ( _hd_isIdentifier,_hd_isOperator,_hd_isSpecial,_hd_text) =
            (_hd )
        ( _tl_isIdentifier,_tl_isOperator,_tl_isSpecial,_tl_text) =
            (_tl )
    in  (_hd_isIdentifier  :  _tl_isIdentifier,_hd_isOperator  :  _tl_isOperator,_hd_isSpecial  :  _tl_isSpecial,_hd_text  :  _tl_text)
sem_Names_Nil :: (T_Names)
sem_Names_Nil  =
    let 
    in  ([],[],[],[])
-- Pattern -----------------------------------------------------
-- semantic domain
type T_Pattern = ((Doc))
-- cata
sem_Pattern :: (Pattern) ->
               (T_Pattern)
sem_Pattern ((Pattern_As (_range) (_name) (_pattern))) =
    (sem_Pattern_As ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Pattern (_pattern))))
sem_Pattern ((Pattern_Constructor (_range) (_name) (_patterns))) =
    (sem_Pattern_Constructor ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Patterns (_patterns))))
sem_Pattern ((Pattern_InfixConstructor (_range) (_leftPattern) (_constructorOperator) (_rightPattern))) =
    (sem_Pattern_InfixConstructor ((sem_Range (_range))) ((sem_Pattern (_leftPattern))) ((sem_Name (_constructorOperator))) ((sem_Pattern (_rightPattern))))
sem_Pattern ((Pattern_Irrefutable (_range) (_pattern))) =
    (sem_Pattern_Irrefutable ((sem_Range (_range))) ((sem_Pattern (_pattern))))
sem_Pattern ((Pattern_List (_range) (_patterns))) =
    (sem_Pattern_List ((sem_Range (_range))) ((sem_Patterns (_patterns))))
sem_Pattern ((Pattern_Literal (_range) (_literal))) =
    (sem_Pattern_Literal ((sem_Range (_range))) ((sem_Literal (_literal))))
sem_Pattern ((Pattern_Negate (_range) (_literal))) =
    (sem_Pattern_Negate ((sem_Range (_range))) ((sem_Literal (_literal))))
sem_Pattern ((Pattern_NegateFloat (_range) (_literal))) =
    (sem_Pattern_NegateFloat ((sem_Range (_range))) ((sem_Literal (_literal))))
sem_Pattern ((Pattern_Parenthesized (_range) (_pattern))) =
    (sem_Pattern_Parenthesized ((sem_Range (_range))) ((sem_Pattern (_pattern))))
sem_Pattern ((Pattern_Record (_range) (_name) (_recordPatternBindings))) =
    (sem_Pattern_Record ((sem_Range (_range))) ((sem_Name (_name))) ((sem_RecordPatternBindings (_recordPatternBindings))))
sem_Pattern ((Pattern_Successor (_range) (_name) (_literal))) =
    (sem_Pattern_Successor ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Literal (_literal))))
sem_Pattern ((Pattern_Tuple (_range) (_patterns))) =
    (sem_Pattern_Tuple ((sem_Range (_range))) ((sem_Patterns (_patterns))))
sem_Pattern ((Pattern_Variable (_range) (_name))) =
    (sem_Pattern_Variable ((sem_Range (_range))) ((sem_Name (_name))))
sem_Pattern ((Pattern_Wildcard (_range))) =
    (sem_Pattern_Wildcard ((sem_Range (_range))))
sem_Pattern_As :: (T_Range) ->
                  (T_Name) ->
                  (T_Pattern) ->
                  (T_Pattern)
sem_Pattern_As (_range) (_name) (_pattern) =
    let (_text) =
            _name_text <> text "@" <> _pattern_text
        ( _range_text) =
            (_range )
        ( _name_isIdentifier,_name_isOperator,_name_isSpecial,_name_text) =
            (_name )
        ( _pattern_text) =
            (_pattern )
    in  (_text)
sem_Pattern_Constructor :: (T_Range) ->
                           (T_Name) ->
                           (T_Patterns) ->
                           (T_Pattern)
sem_Pattern_Constructor (_range) (_name) (_patterns) =
    let (_text) =
            foldl (<+>) (parensIf _name_isOperator _name_text) _patterns_text
        ( _range_text) =
            (_range )
        ( _name_isIdentifier,_name_isOperator,_name_isSpecial,_name_text) =
            (_name )
        ( _patterns_text) =
            (_patterns )
    in  (_text)
sem_Pattern_InfixConstructor :: (T_Range) ->
                                (T_Pattern) ->
                                (T_Name) ->
                                (T_Pattern) ->
                                (T_Pattern)
sem_Pattern_InfixConstructor (_range) (_leftPattern) (_constructorOperator) (_rightPattern) =
    let (_text) =
            parens _leftPattern_text <+> _constructorOperator_text <+> parens _rightPattern_text
        ( _range_text) =
            (_range )
        ( _leftPattern_text) =
            (_leftPattern )
        ( _constructorOperator_isIdentifier,_constructorOperator_isOperator,_constructorOperator_isSpecial,_constructorOperator_text) =
            (_constructorOperator )
        ( _rightPattern_text) =
            (_rightPattern )
    in  (_text)
sem_Pattern_Irrefutable :: (T_Range) ->
                           (T_Pattern) ->
                           (T_Pattern)
sem_Pattern_Irrefutable (_range) (_pattern) =
    let (_text) =
            text "~" <> _pattern_text
        ( _range_text) =
            (_range )
        ( _pattern_text) =
            (_pattern )
    in  (_text)
sem_Pattern_List :: (T_Range) ->
                    (T_Patterns) ->
                    (T_Pattern)
sem_Pattern_List (_range) (_patterns) =
    let (_text) =
            list _patterns_text
        ( _range_text) =
            (_range )
        ( _patterns_text) =
            (_patterns )
    in  (_text)
sem_Pattern_Literal :: (T_Range) ->
                       (T_Literal) ->
                       (T_Pattern)
sem_Pattern_Literal (_range) (_literal) =
    let (_text) =
            _literal_text
        ( _range_text) =
            (_range )
        ( _literal_text) =
            (_literal )
    in  (_text)
sem_Pattern_Negate :: (T_Range) ->
                      (T_Literal) ->
                      (T_Pattern)
sem_Pattern_Negate (_range) (_literal) =
    let (_text) =
            text "-" <> _literal_text
        ( _range_text) =
            (_range )
        ( _literal_text) =
            (_literal )
    in  (_text)
sem_Pattern_NegateFloat :: (T_Range) ->
                           (T_Literal) ->
                           (T_Pattern)
sem_Pattern_NegateFloat (_range) (_literal) =
    let (_text) =
            text "-." <> _literal_text
        ( _range_text) =
            (_range )
        ( _literal_text) =
            (_literal )
    in  (_text)
sem_Pattern_Parenthesized :: (T_Range) ->
                             (T_Pattern) ->
                             (T_Pattern)
sem_Pattern_Parenthesized (_range) (_pattern) =
    let (_text) =
            parens _pattern_text
        ( _range_text) =
            (_range )
        ( _pattern_text) =
            (_pattern )
    in  (_text)
sem_Pattern_Record :: (T_Range) ->
                      (T_Name) ->
                      (T_RecordPatternBindings) ->
                      (T_Pattern)
sem_Pattern_Record (_range) (_name) (_recordPatternBindings) =
    let (_text) =
            text "{- !!! record pattern -}"
        ( _range_text) =
            (_range )
        ( _name_isIdentifier,_name_isOperator,_name_isSpecial,_name_text) =
            (_name )
        ( _recordPatternBindings_text) =
            (_recordPatternBindings )
    in  (_text)
sem_Pattern_Successor :: (T_Range) ->
                         (T_Name) ->
                         (T_Literal) ->
                         (T_Pattern)
sem_Pattern_Successor (_range) (_name) (_literal) =
    let (_text) =
            _name_text <+> text "+" <+> _literal_text
        ( _range_text) =
            (_range )
        ( _name_isIdentifier,_name_isOperator,_name_isSpecial,_name_text) =
            (_name )
        ( _literal_text) =
            (_literal )
    in  (_text)
sem_Pattern_Tuple :: (T_Range) ->
                     (T_Patterns) ->
                     (T_Pattern)
sem_Pattern_Tuple (_range) (_patterns) =
    let (_text) =
            tupled _patterns_text
        ( _range_text) =
            (_range )
        ( _patterns_text) =
            (_patterns )
    in  (_text)
sem_Pattern_Variable :: (T_Range) ->
                        (T_Name) ->
                        (T_Pattern)
sem_Pattern_Variable (_range) (_name) =
    let (_text) =
            _name_text
        ( _range_text) =
            (_range )
        ( _name_isIdentifier,_name_isOperator,_name_isSpecial,_name_text) =
            (_name )
    in  (_text)
sem_Pattern_Wildcard :: (T_Range) ->
                        (T_Pattern)
sem_Pattern_Wildcard (_range) =
    let (_text) =
            text "_"
        ( _range_text) =
            (_range )
    in  (_text)
-- Patterns ----------------------------------------------------
-- semantic domain
type T_Patterns = (( [       Doc ] ))
-- cata
sem_Patterns :: (Patterns) ->
                (T_Patterns)
sem_Patterns (list) =
    (foldr (sem_Patterns_Cons) (sem_Patterns_Nil) ((map sem_Pattern list)))
sem_Patterns_Cons :: (T_Pattern) ->
                     (T_Patterns) ->
                     (T_Patterns)
sem_Patterns_Cons (_hd) (_tl) =
    let ( _hd_text) =
            (_hd )
        ( _tl_text) =
            (_tl )
    in  (_hd_text  :  _tl_text)
sem_Patterns_Nil :: (T_Patterns)
sem_Patterns_Nil  =
    let 
    in  ([])
-- Position ----------------------------------------------------
-- semantic domain
type T_Position = ((Doc))
-- cata
sem_Position :: (Position) ->
                (T_Position)
sem_Position ((Position_Position (_filename) (_line) (_column))) =
    (sem_Position_Position (_filename) (_line) (_column))
sem_Position ((Position_Unknown )) =
    (sem_Position_Unknown )
sem_Position_Position :: (String) ->
                         (Int) ->
                         (Int) ->
                         (T_Position)
sem_Position_Position (_filename) (_line) (_column) =
    let (_text) =
            text _filename <> tupled [int _line, int _column]
    in  (_text)
sem_Position_Unknown :: (T_Position)
sem_Position_Unknown  =
    let (_text) =
            text "Unknown"
    in  (_text)
-- Qualifier ---------------------------------------------------
-- semantic domain
type T_Qualifier = ((Doc))
-- cata
sem_Qualifier :: (Qualifier) ->
                 (T_Qualifier)
sem_Qualifier ((Qualifier_Empty (_range))) =
    (sem_Qualifier_Empty ((sem_Range (_range))))
sem_Qualifier ((Qualifier_Generator (_range) (_pattern) (_expression))) =
    (sem_Qualifier_Generator ((sem_Range (_range))) ((sem_Pattern (_pattern))) ((sem_Expression (_expression))))
sem_Qualifier ((Qualifier_Guard (_range) (_guard))) =
    (sem_Qualifier_Guard ((sem_Range (_range))) ((sem_Expression (_guard))))
sem_Qualifier ((Qualifier_Let (_range) (_declarations))) =
    (sem_Qualifier_Let ((sem_Range (_range))) ((sem_Declarations (_declarations))))
sem_Qualifier_Empty :: (T_Range) ->
                       (T_Qualifier)
sem_Qualifier_Empty (_range) =
    let (_text) =
            empty
        ( _range_text) =
            (_range )
    in  (_text)
sem_Qualifier_Generator :: (T_Range) ->
                           (T_Pattern) ->
                           (T_Expression) ->
                           (T_Qualifier)
sem_Qualifier_Generator (_range) (_pattern) (_expression) =
    let (_text) =
            _pattern_text <+> text "<-" <+> _expression_text
        ( _range_text) =
            (_range )
        ( _pattern_text) =
            (_pattern )
        ( _expression_text) =
            (_expression )
    in  (_text)
sem_Qualifier_Guard :: (T_Range) ->
                       (T_Expression) ->
                       (T_Qualifier)
sem_Qualifier_Guard (_range) (_guard) =
    let (_text) =
            _guard_text
        ( _range_text) =
            (_range )
        ( _guard_text) =
            (_guard )
    in  (_text)
sem_Qualifier_Let :: (T_Range) ->
                     (T_Declarations) ->
                     (T_Qualifier)
sem_Qualifier_Let (_range) (_declarations) =
    let (_text) =
            text "let" <$> (indent 4 $ vcat _declarations_text)
        ( _range_text) =
            (_range )
        ( _declarations_text) =
            (_declarations )
    in  (_text)
-- Qualifiers --------------------------------------------------
-- semantic domain
type T_Qualifiers = (( [       Doc ] ))
-- cata
sem_Qualifiers :: (Qualifiers) ->
                  (T_Qualifiers)
sem_Qualifiers (list) =
    (foldr (sem_Qualifiers_Cons) (sem_Qualifiers_Nil) ((map sem_Qualifier list)))
sem_Qualifiers_Cons :: (T_Qualifier) ->
                       (T_Qualifiers) ->
                       (T_Qualifiers)
sem_Qualifiers_Cons (_hd) (_tl) =
    let ( _hd_text) =
            (_hd )
        ( _tl_text) =
            (_tl )
    in  (_hd_text  :  _tl_text)
sem_Qualifiers_Nil :: (T_Qualifiers)
sem_Qualifiers_Nil  =
    let 
    in  ([])
-- Range -------------------------------------------------------
-- semantic domain
type T_Range = ((Doc))
-- cata
sem_Range :: (Range) ->
             (T_Range)
sem_Range ((Range_Range (_start) (_stop))) =
    (sem_Range_Range ((sem_Position (_start))) ((sem_Position (_stop))))
sem_Range_Range :: (T_Position) ->
                   (T_Position) ->
                   (T_Range)
sem_Range_Range (_start) (_stop) =
    let (_text) =
            text "{-" <+> _start_text <+> text ", " <+> _stop_text <+> text "-}"
        ( _start_text) =
            (_start )
        ( _stop_text) =
            (_stop )
    in  (_text)
-- RecordExpressionBinding -------------------------------------
-- semantic domain
type T_RecordExpressionBinding = ((Doc))
-- cata
sem_RecordExpressionBinding :: (RecordExpressionBinding) ->
                               (T_RecordExpressionBinding)
sem_RecordExpressionBinding ((RecordExpressionBinding_RecordExpressionBinding (_range) (_name) (_expression))) =
    (sem_RecordExpressionBinding_RecordExpressionBinding ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Expression (_expression))))
sem_RecordExpressionBinding_RecordExpressionBinding :: (T_Range) ->
                                                       (T_Name) ->
                                                       (T_Expression) ->
                                                       (T_RecordExpressionBinding)
sem_RecordExpressionBinding_RecordExpressionBinding (_range) (_name) (_expression) =
    let (_text) =
            text "{- !!! record expression binding -}"
        ( _range_text) =
            (_range )
        ( _name_isIdentifier,_name_isOperator,_name_isSpecial,_name_text) =
            (_name )
        ( _expression_text) =
            (_expression )
    in  (_text)
-- RecordExpressionBindings ------------------------------------
-- semantic domain
type T_RecordExpressionBindings = (( [       Doc ] ))
-- cata
sem_RecordExpressionBindings :: (RecordExpressionBindings) ->
                                (T_RecordExpressionBindings)
sem_RecordExpressionBindings (list) =
    (foldr (sem_RecordExpressionBindings_Cons) (sem_RecordExpressionBindings_Nil) ((map sem_RecordExpressionBinding list)))
sem_RecordExpressionBindings_Cons :: (T_RecordExpressionBinding) ->
                                     (T_RecordExpressionBindings) ->
                                     (T_RecordExpressionBindings)
sem_RecordExpressionBindings_Cons (_hd) (_tl) =
    let ( _hd_text) =
            (_hd )
        ( _tl_text) =
            (_tl )
    in  (_hd_text  :  _tl_text)
sem_RecordExpressionBindings_Nil :: (T_RecordExpressionBindings)
sem_RecordExpressionBindings_Nil  =
    let 
    in  ([])
-- RecordPatternBinding ----------------------------------------
-- semantic domain
type T_RecordPatternBinding = ((Doc))
-- cata
sem_RecordPatternBinding :: (RecordPatternBinding) ->
                            (T_RecordPatternBinding)
sem_RecordPatternBinding ((RecordPatternBinding_RecordPatternBinding (_range) (_name) (_pattern))) =
    (sem_RecordPatternBinding_RecordPatternBinding ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Pattern (_pattern))))
sem_RecordPatternBinding_RecordPatternBinding :: (T_Range) ->
                                                 (T_Name) ->
                                                 (T_Pattern) ->
                                                 (T_RecordPatternBinding)
sem_RecordPatternBinding_RecordPatternBinding (_range) (_name) (_pattern) =
    let (_text) =
            text "{- !!! record pattern binding -}"
        ( _range_text) =
            (_range )
        ( _name_isIdentifier,_name_isOperator,_name_isSpecial,_name_text) =
            (_name )
        ( _pattern_text) =
            (_pattern )
    in  (_text)
-- RecordPatternBindings ---------------------------------------
-- semantic domain
type T_RecordPatternBindings = (( [       Doc ] ))
-- cata
sem_RecordPatternBindings :: (RecordPatternBindings) ->
                             (T_RecordPatternBindings)
sem_RecordPatternBindings (list) =
    (foldr (sem_RecordPatternBindings_Cons) (sem_RecordPatternBindings_Nil) ((map sem_RecordPatternBinding list)))
sem_RecordPatternBindings_Cons :: (T_RecordPatternBinding) ->
                                  (T_RecordPatternBindings) ->
                                  (T_RecordPatternBindings)
sem_RecordPatternBindings_Cons (_hd) (_tl) =
    let ( _hd_text) =
            (_hd )
        ( _tl_text) =
            (_tl )
    in  (_hd_text  :  _tl_text)
sem_RecordPatternBindings_Nil :: (T_RecordPatternBindings)
sem_RecordPatternBindings_Nil  =
    let 
    in  ([])
-- RightHandSide -----------------------------------------------
-- semantic domain
type T_RightHandSide = (( Doc        -> Doc  ))
-- cata
sem_RightHandSide :: (RightHandSide) ->
                     (T_RightHandSide)
sem_RightHandSide ((RightHandSide_Expression (_range) (_expression) (_where))) =
    (sem_RightHandSide_Expression ((sem_Range (_range))) ((sem_Expression (_expression))) ((sem_MaybeDeclarations (_where))))
sem_RightHandSide ((RightHandSide_Guarded (_range) (_guardedexpressions) (_where))) =
    (sem_RightHandSide_Guarded ((sem_Range (_range))) ((sem_GuardedExpressions (_guardedexpressions))) ((sem_MaybeDeclarations (_where))))
sem_RightHandSide_Expression :: (T_Range) ->
                                (T_Expression) ->
                                (T_MaybeDeclarations) ->
                                (T_RightHandSide)
sem_RightHandSide_Expression (_range) (_expression) (_where) =
    let (_text) =
            \assign       -> assign <$> _justText
        (_justText) =
            indent 4
                (  _expression_text
                <> maybe
                       empty
                       (\ds -> PPrint.empty <$> text "where" <$> indent 4 (vcat ds))
                       _where_text
                )
        ( _range_text) =
            (_range )
        ( _expression_text) =
            (_expression )
        ( _where_text) =
            (_where )
    in  (_text)
sem_RightHandSide_Guarded :: (T_Range) ->
                             (T_GuardedExpressions) ->
                             (T_MaybeDeclarations) ->
                             (T_RightHandSide)
sem_RightHandSide_Guarded (_range) (_guardedexpressions) (_where) =
    let (_text) =
            \assign ->
                (   PPrint.empty
                <$> vsep
                       (zipWith (\f x -> indent 4 (f x)) _guardedexpressions_text (repeat assign))
                <>  maybe
                       empty
                       (\ds -> PPrint.empty <$> indent 4 (text "where" <$> indent 4 (vcat ds)))
                       _where_text
                )
        ( _range_text) =
            (_range )
        ( _guardedexpressions_text) =
            (_guardedexpressions )
        ( _where_text) =
            (_where )
    in  (_text)
-- SimpleType --------------------------------------------------
-- semantic domain
type T_SimpleType = ((Doc))
-- cata
sem_SimpleType :: (SimpleType) ->
                  (T_SimpleType)
sem_SimpleType ((SimpleType_SimpleType (_range) (_name) (_typevariables))) =
    (sem_SimpleType_SimpleType ((sem_Range (_range))) ((sem_Name (_name))) ((sem_Names (_typevariables))))
sem_SimpleType_SimpleType :: (T_Range) ->
                             (T_Name) ->
                             (T_Names) ->
                             (T_SimpleType)
sem_SimpleType_SimpleType (_range) (_name) (_typevariables) =
    let (_text) =
            foldl (<+>) _name_text _typevariables_text
        ( _range_text) =
            (_range )
        ( _name_isIdentifier,_name_isOperator,_name_isSpecial,_name_text) =
            (_name )
        ( _typevariables_isIdentifier,_typevariables_isOperator,_typevariables_isSpecial,_typevariables_text) =
            (_typevariables )
    in  (_text)
-- Statement ---------------------------------------------------
-- semantic domain
type T_Statement = ((Doc))
-- cata
sem_Statement :: (Statement) ->
                 (T_Statement)
sem_Statement ((Statement_Empty (_range))) =
    (sem_Statement_Empty ((sem_Range (_range))))
sem_Statement ((Statement_Expression (_range) (_expression))) =
    (sem_Statement_Expression ((sem_Range (_range))) ((sem_Expression (_expression))))
sem_Statement ((Statement_Generator (_range) (_pattern) (_expression))) =
    (sem_Statement_Generator ((sem_Range (_range))) ((sem_Pattern (_pattern))) ((sem_Expression (_expression))))
sem_Statement ((Statement_Let (_range) (_declarations))) =
    (sem_Statement_Let ((sem_Range (_range))) ((sem_Declarations (_declarations))))
sem_Statement_Empty :: (T_Range) ->
                       (T_Statement)
sem_Statement_Empty (_range) =
    let (_text) =
            empty
        ( _range_text) =
            (_range )
    in  (_text)
sem_Statement_Expression :: (T_Range) ->
                            (T_Expression) ->
                            (T_Statement)
sem_Statement_Expression (_range) (_expression) =
    let (_text) =
            _expression_text
        ( _range_text) =
            (_range )
        ( _expression_text) =
            (_expression )
    in  (_text)
sem_Statement_Generator :: (T_Range) ->
                           (T_Pattern) ->
                           (T_Expression) ->
                           (T_Statement)
sem_Statement_Generator (_range) (_pattern) (_expression) =
    let (_text) =
            _pattern_text <+> text "<-" <+> _expression_text
        ( _range_text) =
            (_range )
        ( _pattern_text) =
            (_pattern )
        ( _expression_text) =
            (_expression )
    in  (_text)
sem_Statement_Let :: (T_Range) ->
                     (T_Declarations) ->
                     (T_Statement)
sem_Statement_Let (_range) (_declarations) =
    let (_text) =
            text "let" <$> (indent 4 $ vcat _declarations_text)
        ( _range_text) =
            (_range )
        ( _declarations_text) =
            (_declarations )
    in  (_text)
-- Statements --------------------------------------------------
-- semantic domain
type T_Statements = (( [       Doc ] ))
-- cata
sem_Statements :: (Statements) ->
                  (T_Statements)
sem_Statements (list) =
    (foldr (sem_Statements_Cons) (sem_Statements_Nil) ((map sem_Statement list)))
sem_Statements_Cons :: (T_Statement) ->
                       (T_Statements) ->
                       (T_Statements)
sem_Statements_Cons (_hd) (_tl) =
    let ( _hd_text) =
            (_hd )
        ( _tl_text) =
            (_tl )
    in  (_hd_text  :  _tl_text)
sem_Statements_Nil :: (T_Statements)
sem_Statements_Nil  =
    let 
    in  ([])
-- Strings -----------------------------------------------------
-- semantic domain
type T_Strings = (( [       Doc ] ))
-- cata
sem_Strings :: (Strings) ->
               (T_Strings)
sem_Strings (list) =
    (foldr (sem_Strings_Cons) (sem_Strings_Nil) (list))
sem_Strings_Cons :: (String) ->
                    (T_Strings) ->
                    (T_Strings)
sem_Strings_Cons (_hd) (_tl) =
    let ( _tl_text) =
            (_tl )
    in  (_tl_text)
sem_Strings_Nil :: (T_Strings)
sem_Strings_Nil  =
    let 
    in  ([])
-- Type --------------------------------------------------------
-- semantic domain
type T_Type = ((Doc))
-- cata
sem_Type :: (Type) ->
            (T_Type)
sem_Type ((Type_Application (_range) (_prefix) (_function) (_arguments))) =
    (sem_Type_Application ((sem_Range (_range))) (_prefix) ((sem_Type (_function))) ((sem_Types (_arguments))))
sem_Type ((Type_Constructor (_range) (_name))) =
    (sem_Type_Constructor ((sem_Range (_range))) ((sem_Name (_name))))
sem_Type ((Type_Exists (_range) (_typevariables) (_type))) =
    (sem_Type_Exists ((sem_Range (_range))) ((sem_Names (_typevariables))) ((sem_Type (_type))))
sem_Type ((Type_Forall (_range) (_typevariables) (_type))) =
    (sem_Type_Forall ((sem_Range (_range))) ((sem_Names (_typevariables))) ((sem_Type (_type))))
sem_Type ((Type_Parenthesized (_range) (_type))) =
    (sem_Type_Parenthesized ((sem_Range (_range))) ((sem_Type (_type))))
sem_Type ((Type_Qualified (_range) (_context) (_type))) =
    (sem_Type_Qualified ((sem_Range (_range))) ((sem_ContextItems (_context))) ((sem_Type (_type))))
sem_Type ((Type_Variable (_range) (_name))) =
    (sem_Type_Variable ((sem_Range (_range))) ((sem_Name (_name))))
sem_Type_Application :: (T_Range) ->
                        (Bool) ->
                        (T_Type) ->
                        (T_Types) ->
                        (T_Type)
sem_Type_Application (_range) (_prefix) (_function) (_arguments) =
    let (_text) =
            if _prefix then
                foldl (<+>) _function_text _arguments_text
            else if show _function_text == "[]" then
                list _arguments_text
            else if isTupleConstructor (show _function_text) then
                tupled _arguments_text
            else
                case _arguments_text of
                    [a, b] -> a <+> _function_text <+> b
                    as     -> text "{- error: Unknown special application notation -}"
        ( _range_text) =
            (_range )
        ( _function_text) =
            (_function )
        ( _arguments_text) =
            (_arguments )
    in  (_text)
sem_Type_Constructor :: (T_Range) ->
                        (T_Name) ->
                        (T_Type)
sem_Type_Constructor (_range) (_name) =
    let (_text) =
            _name_text
        ( _range_text) =
            (_range )
        ( _name_isIdentifier,_name_isOperator,_name_isSpecial,_name_text) =
            (_name )
    in  (_text)
sem_Type_Exists :: (T_Range) ->
                   (T_Names) ->
                   (T_Type) ->
                   (T_Type)
sem_Type_Exists (_range) (_typevariables) (_type) =
    let (_text) =
            foldl (<+>) (text "exists") _typevariables_text <> text "." <> _type_text
        ( _range_text) =
            (_range )
        ( _typevariables_isIdentifier,_typevariables_isOperator,_typevariables_isSpecial,_typevariables_text) =
            (_typevariables )
        ( _type_text) =
            (_type )
    in  (_text)
sem_Type_Forall :: (T_Range) ->
                   (T_Names) ->
                   (T_Type) ->
                   (T_Type)
sem_Type_Forall (_range) (_typevariables) (_type) =
    let (_text) =
            foldl (<+>) (text "forall") _typevariables_text <> text "." <> _type_text
        ( _range_text) =
            (_range )
        ( _typevariables_isIdentifier,_typevariables_isOperator,_typevariables_isSpecial,_typevariables_text) =
            (_typevariables )
        ( _type_text) =
            (_type )
    in  (_text)
sem_Type_Parenthesized :: (T_Range) ->
                          (T_Type) ->
                          (T_Type)
sem_Type_Parenthesized (_range) (_type) =
    let (_text) =
            parens _type_text
        ( _range_text) =
            (_range )
        ( _type_text) =
            (_type )
    in  (_text)
sem_Type_Qualified :: (T_Range) ->
                      (T_ContextItems) ->
                      (T_Type) ->
                      (T_Type)
sem_Type_Qualified (_range) (_context) (_type) =
    let (_text) =
            text "{- !!! qualified type -}"
        ( _range_text) =
            (_range )
        ( _context_text) =
            (_context )
        ( _type_text) =
            (_type )
    in  (_text)
sem_Type_Variable :: (T_Range) ->
                     (T_Name) ->
                     (T_Type)
sem_Type_Variable (_range) (_name) =
    let (_text) =
            _name_text
        ( _range_text) =
            (_range )
        ( _name_isIdentifier,_name_isOperator,_name_isSpecial,_name_text) =
            (_name )
    in  (_text)
-- Types -------------------------------------------------------
-- semantic domain
type T_Types = (( [       Doc ] ))
-- cata
sem_Types :: (Types) ->
             (T_Types)
sem_Types (list) =
    (foldr (sem_Types_Cons) (sem_Types_Nil) ((map sem_Type list)))
sem_Types_Cons :: (T_Type) ->
                  (T_Types) ->
                  (T_Types)
sem_Types_Cons (_hd) (_tl) =
    let ( _hd_text) =
            (_hd )
        ( _tl_text) =
            (_tl )
    in  (_hd_text  :  _tl_text)
sem_Types_Nil :: (T_Types)
sem_Types_Nil  =
    let 
    in  ([])

